# IoncubeEncoderTask

Extends \Task

Invokes the ionCube Encoder (PHP4 or PHP5)

Use \Project#createTask to register a new Task.

author | Michiel Rook mrook@php.net
author | Andrew Eddie andrew.eddie@jamboworks.com
author | Domenico Sgarbossa sbraaaa@yahoo.it
version | $Id: e3be6295e522bb62877c0ace6a0d5ef6bf18d161 $
package | phing.tasks.ext.ioncube
since | 2.2.0

### Methods

## Adds a comment to be used in encoded files

    addComment(\IoncubeComment $comment)

### Arguments

#### $comment

`\IoncubeComment`

## Constructs an argument string for the ionCube encoder

    constructArguments()

## Returns the action-if-no-loader option

    getActionIfNoLoader()

## Returns the allowed server setting

    getAllowedServer()

## Returns the allow-encoding-into-source option

    getAllowEncodingIntoSource()

## Returns the binary option

    getBinary()

## Returns the callback-file option

    getCallbackFile()

## Returns the copy setting

    getCopy()

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the encode setting

    getEncode()

## Returns regexps of additional files to encrypt (separated by space)

    getEncrypt()

## Returns the expireIn setting

    getExpirein()

## Returns the expireOn setting

    getExpireon()

## Returns the source directory

    getFromDir()

## Returns the ignore setting

    getIgnore()

## Returns the ignore-deprecated-warnings option

    getIgnoreDeprecatedWarnings()

## Returns the ignore-strict-warnings option

    getIgnoreStrictWarnings()

## Returns the path to the ionCube encoder

    getIoncubePath()

## Returns the ignore setting

    getKeep()

## Returns the path to the license file to use

    getLicensePath()

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the message-if-no-loader option

    getMessageIfNoLoader()

## Returns the no-doc-comments option

    getNoDocComments()

## Returns the no-short-open-tags option

    getNoShortOpenTags()

## Returns the optimize option

    getObfuscate()

## Returns the obfuscation-exclusions-file option

    getObfuscationExclusionFile()

## Returns the optimize option

    getObfuscationKey()

## Returns the optimize option

    getOptimize()

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns the passphrase to use when encoding files

    getPassPhrase()

## Returns the version of PHP to use (defaults to 5)

    getPhpVersion()

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the option to use when encoding target directory already exists (defaults to none)

    getTargetOption()

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Returns the target directory

    getToDir()

## Returns the without-runtime-loader-support option

    getWithoutRuntimeLoaderSupport()

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Sets the action-if-no-loader option

    setActionIfNoLoader( $value)

### Arguments

#### $value

``

## Sets the allowed server

    setAllowedServer( $value)

### Arguments

#### $value

``

## Sets the allow-encoding-into-source option

    setAllowEncodingIntoSource( $value)

### Arguments

#### $value

``

## Sets the binary option

    setBinary( $value)

### Arguments

#### $value

``

## Sets the callback-file option

    setCallbackFile( $value)

### Arguments

#### $value

``

## Sets files or folders to copy (separated by space)

    setCopy( $value)

### Arguments

#### $value

``

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Sets additional file patterns, files or directories to encode, or to reverse the effect of copy (separated by space)

    setEncode( $value)

### Arguments

#### $value

``

## Sets regexps of additional files to encrypt (separated by space)

    setEncrypt( $value)

### Arguments

#### $value

``

## Sets a period after which the files expire

    setExpirein( $value)

### Arguments

#### $value

``

## Sets a YYYY-MM-DD date to expire the files

    setExpireon( $value)

### Arguments

#### $value

``

## Sets the source directory

    setFromDir( $value)

### Arguments

#### $value

``

## Set files and directories to ignore entirely and exclude from the target directory (separated by space).

    setIgnore( $value)

### Arguments

#### $value

``

## Sets the ignore-deprecated-warnings option

    setIgnoreDeprecatedWarnings( $value)

### Arguments

#### $value

``

## Sets the ignore-strict-warnings option

    setIgnoreStrictWarnings( $value)

### Arguments

#### $value

``

## Sets the path to the ionCube encoder

    setIoncubePath( $value)

### Arguments

#### $value

``

## Set files and directories not to be ignored (separated by space).

    setKeep( $value)

### Arguments

#### $value

``

## Sets the path to the license file to use

    setLicensePath( $value)

### Arguments

#### $value

``

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the message-if-no-loader option

    setMessageIfNoLoader( $value)

### Arguments

#### $value

``

## Sets the no-doc-comments option

    setNoDocComments( $value)

### Arguments

#### $value

``

## Sets the no-short-open-tags option

    setNoShortOpenTags( $value)

### Arguments

#### $value

``

## Sets the obfuscate option

    setObfuscate( $value)

### Arguments

#### $value

``

## Sets the obfuscation-exclusions-file option

    setObfuscationExclusionFile( $value)

### Arguments

#### $value

``

## Sets the obfuscation key (required if using the obfuscate option)

    setObfuscationKey( $value)

### Arguments

#### $value

``

## Sets the optimize option

    setOptimize( $value)

### Arguments

#### $value

``

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Sets the passphrase to use when encoding files

    setPassPhrase( $value)

### Arguments

#### $value

``

## Sets the version of PHP to use (defaults to 5)

    setPhpVersion( $value)

### Arguments

#### $value

``

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets whether to show command line before it is executed

    setShowCommandLine( $value)

### Arguments

#### $value

``

## Sets the option to use when encoding target directory already exists (defaults to none)

    setTargetOption( $targetOption)

### Arguments

#### $targetOption

``

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Sets the target directory

    setToDir( $value)

### Arguments

#### $value

``

## Sets the without-runtime-loader-support option

    setWithoutRuntimeLoaderSupport( $value)

### Arguments

#### $value

``

### Properties

## ionSwitches

    ionSwitches :

### Type(s)

``

## ionOptions

    ionOptions :

### Type(s)

``

## ionOptionsXS

    ionOptionsXS :

### Type(s)

``

## comments

    comments :

### Type(s)

``

## encoderName

    encoderName :

### Type(s)

``

## fromDir

    fromDir :

### Type(s)

``

## ioncubePath

    ioncubePath :

### Type(s)

``

## phpVersion

    phpVersion :

### Type(s)

``

## targetOption

    targetOption :

### Type(s)

``

## toDir

    toDir :

### Type(s)

``

## showCommandLine

    showCommandLine :

### Type(s)

``

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`